﻿using System;
using WindowsPE;

namespace ConsoleApp1
{
    class Program
    {
        static void Main(string[] _)
        {
            {
                PEImage img = PEImage.ReadFromFile(@"ClassLibrary1.dll");
                WriteInfo(img);
            }

            Console.WriteLine();

            {
                PEImage img = PEImage.ReadFromFile(@"Test.dll");
                WriteInfo(img);
            }
        }

        public static void WriteInfo(PEImage img)
        {
            if (img == null)
            {
                Console.WriteLine("img == null");
                return;
            }

            /*
            IMAGE_COR20_HEADER corHeader = img.GetClrDirectoryHeader();
            Console.WriteLine($"RuntimeVersion: {corHeader.RuntimeVersion:x}, VTable Size: {corHeader.VTableFixups.Size}");

            VTableFixups [] vtfs = img.Reads<VTableFixups>(corHeader.VTableFixups.VirtualAddress, corHeader.VTableFixups.Size);

            foreach (var vtf in vtfs)
            {
                Console.WriteLine(vtf + ", " + vtf.Type.ToString());
            }
            */

            foreach (var vtf in img.EnumerateVTableFixups())
            {
                Console.WriteLine(vtf + ", " + vtf.Type.ToString());

                for (int i = 0; i < vtf.Count; i++)
                {
                    int itemSize = vtf.GetItemSize();
                    uint itemPos = (uint)(vtf.rva + (i * itemSize));

                    long vtableItem = (itemSize == 8) ? img.Read<long>(itemPos) : img.Read<int>(itemPos);
                    Console.WriteLine($"\tVTable[{i}] {vtableItem:x}");
                }
            }

            foreach (ExportFunctionInfo efi in img.EnumerateExportFunctions())
            {
                Console.WriteLine($"{efi.Name} at 0x{efi.RvaAddress:x8}");

                byte[] code = img.ReadBytes(efi.RvaAddress, 1024);
            }
        }
    }
}
