﻿using System.IO;
using System.Text;

namespace MakeExport
{
    class Program
    {
        static void Main(string[] args)
        {
            string filePath = args[0];
            string targetPlatform = args[1];

            int index = 1;
            StringBuilder sb = new StringBuilder();

            foreach (string line in File.ReadAllLines(filePath))
            {
                if (line.IndexOf("// Code size") == -1)
                {
                    sb.AppendLine(line);
                }
                else if (line.IndexOf(".corflags") != -1)
                {
                    if (targetPlatform == "x64")
                    {
                        sb.AppendLine(".corflags 0x00000000");
                    }
                    else
                    {
                        sb.AppendLine(".corflags 0x00000002");
                    }
                }
                else
                {
                    sb.AppendLine(line);
                    sb.AppendLine($".export[{index}]");
                    index++;
                }
            }

            File.WriteAllText(filePath, sb.ToString());
        }
    }
}
